const remFontSize = 16;

function rem(factor) {
  return factor * remFontSize;
}

function vh(factor) {
  return factor * 100;
}

const tachyons = {
  flex: { flex: 1 },
  flex0: { flex: 0 },
  flex1: { flex: 0.1 },
  flex2: { flex: 0.2 },
  flex3: { flex: 0.3 },
  flex4: { flex: 0.4 },
  flex5: { flex: 0.5 },
  flex6: { flex: 0.6 },
  flex7: { flex: 0.7 },
  flex8: { flex: 0.8 },
  flex9: { flex: 0.9 },
  'flex-none': { flex: -1 },

  contain: { resizeMode: 'contain' },
  cover: { resizeMode: 'cover' },
  stretch: { resizeMode: 'stretch' },
  ba: { borderStyle: 'solid', borderWidth: 0.7 },
  bt: { borderTopWidth: 0.7 },
  br: { borderRightWidth: 0.7 },
  bb: { borderBottomWidth: 0.7 },
  bl: { borderLeftWidth: 0.7 },
  bn: { borderWidth: 0 },
  bTransparent: { borderColor: 'transparent' },
  br0: { borderRightWidth: 0 },
  br1: { borderRadius: rem(0.125) },
  br2: { borderRadius: rem(0.25) },
  br3: { borderRadius: rem(0.5) },
  br4: { borderRadius: rem(1) },
  brPill: { borderRadius: 9999 },
  'br--bottom': { borderTopLeftRadius: 0, borderTopRightRadius: 0 },
  'br--top': { borderBottomLeftRadius: 0, borderBottomRightRadius: 0 },
  'br--right': { borderTopLeftRadius: 0, borderBottomLeftRadius: 0 },
  'br--left': { borderTopRightRadius: 0, borderBottomRightRadius: 0 },
  'b--dotted': { borderStyle: 'dotted' },
  'b--dashed': { borderStyle: 'dashed' },
  'b--solid': { borderStyle: 'solid' },
  bw0: { borderWidth: 0 },
  bw1: { borderWidth: rem(0.125) },
  bw2: { borderWidth: rem(0.25) },
  bw3: { borderWidth: rem(0.5) },
  bw4: { borderWidth: rem(1) },
  bw5: { borderWidth: rem(2) },
  'bt-0': { borderTopWidth: 0 },
  'bb-0': { borderBottomWidth: 0 },
  'bl-0': { borderLeftWidth: 0 },
  'br-0': { borderRightWidth: 0 },
  'top-0': { top: 0 },
  'right-0': { right: 0 },
  'bottom-0': { bottom: 0 },
  'left-0': { left: 0 },
  'top-1': { top: rem(1) },
  'right-1': { right: rem(1) },
  'bottom-1': { bottom: rem(1) },
  'left-1': { left: rem(1) },
  'top--1': { top: -rem(1) },
  'right--1': { right: -rem(1) },
  'bottom--1': { bottom: -rem(1) },
  'left--1': { left: -rem(1) },
  'top-2': { top: rem(2) },
  'right-2': { right: rem(2) },
  'bottom-2': { bottom: rem(2) },
  'left-2': { left: rem(2) },
  'top--2': { top: -rem(2) },
  'right--2': { right: -rem(2) },
  'bottom--2': { bottom: -rem(2) },
  'left--2': { left: -rem(2) },
  'absolute--fill': { top: 0, right: 0, bottom: 0, left: 0 },
  dn: { display: 'none' },
  'dt--fixed': { width: '100%' },
  'flex-auto': { minWidth: 0 },
  'flex-column': { flexDirection: 'column' },
  'flex-row': { flexDirection: 'row' },
  'flex-wrap': { flexWrap: 'wrap' },
  'flex-nowrap': { flexWrap: 'nowrap' },
  'flex-column-reverse': { flexDirection: 'column-reverse' },
  'flex-row-reverse': { flexDirection: 'row-reverse' },
  'items-start': { alignItems: 'flex-start' },
  'items-end': { alignItems: 'flex-end' },
  'items-center': { alignItems: 'center' },
  'items-baseline': { alignItems: 'baseline' },
  'items-stretch': { alignItems: 'stretch' },
  'self-start': { alignSelf: 'flex-start' },
  'self-end': { alignSelf: 'flex-end' },
  'self-center': { alignSelf: 'center' },
  'self-baseline': { alignSelf: 'baseline' },
  'self-stretch': { alignSelf: 'stretch' },
  'justify-start': { justifyContent: 'flex-start' },
  'justify-end': { justifyContent: 'flex-end' },
  'justify-center': { justifyContent: 'center' },
  'justify-between': { justifyContent: 'space-between' },
  'justify-around': { justifyContent: 'space-around' },
  'flex-grow-0': { flexGrow: 0 },
  'flex-grow-1': { flexGrow: 1 },
  'flex-shrink-0': { flexShrink: 0 },
  'flex-shrink-1': { flexShrink: 1 },

  i: { fontStyle: 'italic' },
  'fs-normal': { fontStyle: 'normal' },
  normal: { fontWeight: 'normal' },
  b: { fontWeight: 'bold' },
  strong: { fontWeight: 'bold' },
  fw1: { fontWeight: '100' },
  fw2: { fontWeight: '200' },
  fw3: { fontWeight: '300' },
  fw4: { fontWeight: '400' },
  fw5: { fontWeight: '500' },
  fw6: { fontWeight: '600' },
  fw7: { fontWeight: '700' },
  fw8: { fontWeight: '800' },
  fw9: { fontWeight: '900' },
  h1: { height: rem(1) },
  h2: { height: rem(2) },
  h3: { height: rem(4) },
  h4: { height: rem(8) },
  h5: { height: rem(16) },
  'h-25': { height: '25%' },
  'h-50': { height: '50%' },
  'h-75': { height: '75%' },
  'h-100': { height: '100%' },
  'min-h-100': { minHeight: '100%' },
  'vh-25': { height: `${vh(0.25)}%` },
  'vh-50': { height: `${vh(0.5)}%` },
  'vh-75': { height: `${vh(0.75)}%` },
  'vh-100': { height: `${vh(1)}%` },
  'min-vh-100': { minHeight: `${vh(1)}%` },
  'h-auto': { height: 'auto' },
  mw100: { maxWidth: '100%' },
  mw1: { maxWidth: rem(1) },
  mw2: { maxWidth: rem(2) },
  mw3: { maxWidth: rem(4) },
  mw4: { maxWidth: rem(8) },
  mw5: { maxWidth: rem(16) },
  mw6: { maxWidth: rem(32) },
  mw7: { maxWidth: rem(48) },
  mw8: { maxWidth: rem(64) },
  mw9: { maxWidth: rem(96) },
  'mw-none': { maxWidth: 'none' },
  w1: { width: rem(1) },
  w2: { width: rem(2) },
  w3: { width: rem(4) },
  w4: { width: rem(8) },
  w5: { width: rem(16) },
  'w-10': { width: '10%' },
  'w-20': { width: '20%' },
  'w-25': { width: '25%' },
  'w-30': { width: '30%' },
  'w-33': { width: '33%' },
  'w-34': { width: '34%' },
  'w-40': { width: '40%' },
  'w-50': { width: '50%' },
  'w-60': { width: '60%' },
  'w-70': { width: '70%' },
  'w-75': { width: '75%' },
  'w-80': { width: '80%' },
  'w-90': { width: '90%' },
  'w-100': { width: '100%' },
  'w-auto': { width: 'auto' },
  'w-third': { width: '33.33333%' },
  'w-two-thirds': { width: '66.66667%' },
  'overflow-visible': { overflow: 'visible' },
  'overflow-hidden': { overflow: 'hidden' },
  relative: { position: 'relative' },
  absolute: { position: 'absolute' },
  'o-100': { opacity: 1 },
  'o-90': { opacity: 0.9 },
  'o-80': { opacity: 0.8 },
  'o-70': { opacity: 0.7 },
  'o-60': { opacity: 0.6 },
  'o-50': { opacity: 0.5 },
  'o-40': { opacity: 0.4 },
  'o-30': { opacity: 0.3 },
  'o-20': { opacity: 0.2 },
  'o-10': { opacity: 0.1 },
  'o-05': { opacity: 0.05 },
  'o-025': { opacity: 0.025 },
  'o-0': { opacity: 0 },
  pa0: { padding: 0 },
  pa1: { padding: rem(0.25) },
  pa2: { padding: rem(0.5) },
  pa3: { padding: rem(1) },
  pa4: { padding: rem(2) },
  pa5: { padding: rem(4) },
  pa6: { padding: rem(8) },
  pa7: { padding: rem(16) },
  pl0: { paddingLeft: 0 },
  pl1: { paddingLeft: rem(0.25) },
  pl2: { paddingLeft: rem(0.5) },
  pl3: { paddingLeft: rem(1) },
  pl4: { paddingLeft: rem(2) },
  pl5: { paddingLeft: rem(4) },
  pl6: { paddingLeft: rem(8) },
  pl7: { paddingLeft: rem(16) },
  pr0: { paddingRight: 0 },
  pr1: { paddingRight: rem(0.25) },
  pr2: { paddingRight: rem(0.5) },
  pr3: { paddingRight: rem(1) },
  pr4: { paddingRight: rem(2) },
  pr5: { paddingRight: rem(4) },
  pr6: { paddingRight: rem(8) },
  pr7: { paddingRight: rem(16) },
  pb0: { paddingBottom: 0 },
  pb1: { paddingBottom: rem(0.25) },
  pb2: { paddingBottom: rem(0.5) },
  pb3: { paddingBottom: rem(1) },
  pb4: { paddingBottom: rem(2) },
  pb5: { paddingBottom: rem(4) },
  pb6: { paddingBottom: rem(8) },
  pb7: { paddingBottom: rem(16) },
  pt0: { paddingTop: 0 },
  pt1: { paddingTop: rem(0.25) },
  pt2: { paddingTop: rem(0.5) },
  pt3: { paddingTop: rem(1) },
  pt4: { paddingTop: rem(2) },
  pt5: { paddingTop: rem(4) },
  pt6: { paddingTop: rem(8) },
  pt7: { paddingTop: rem(16) },
  pv0: { paddingTop: 0, paddingBottom: 0 },
  pv1: { paddingTop: rem(0.25), paddingBottom: rem(0.25) },
  pv2: { paddingTop: rem(0.5), paddingBottom: rem(0.5) },
  pv3: { paddingTop: rem(1), paddingBottom: rem(1) },
  pv4: { paddingTop: rem(2), paddingBottom: rem(2) },
  pv5: { paddingTop: rem(4), paddingBottom: rem(4) },
  pv6: { paddingTop: rem(8), paddingBottom: rem(8) },
  pv7: { paddingTop: rem(16), paddingBottom: rem(16) },
  ph0: { paddingLeft: 0, paddingRight: 0 },
  ph1: { paddingLeft: rem(0.25), paddingRight: rem(0.25) },
  ph2: { paddingLeft: rem(0.5), paddingRight: rem(0.5) },
  ph3: { paddingLeft: rem(1), paddingRight: rem(1) },
  ph4: { paddingLeft: rem(2), paddingRight: rem(2) },
  ph5: { paddingLeft: rem(4), paddingRight: rem(4) },
  ph6: { paddingLeft: rem(8), paddingRight: rem(8) },
  ph7: { paddingLeft: rem(16), paddingRight: rem(16) },
  ma0: { margin: 0 },
  ma1: { margin: rem(0.25) },
  ma2: { margin: rem(0.5) },
  ma3: { margin: rem(1) },
  ma4: { margin: rem(2) },
  ma5: { margin: rem(4) },
  ma6: { margin: rem(8) },
  ma7: { margin: rem(16) },
  ml0: { marginLeft: 0 },
  ml1: { marginLeft: rem(0.25) },
  ml2: { marginLeft: rem(0.5) },
  ml3: { marginLeft: rem(1) },
  ml4: { marginLeft: rem(2) },
  ml5: { marginLeft: rem(4) },
  ml6: { marginLeft: rem(8) },
  ml7: { marginLeft: rem(16) },
  mr0: { marginRight: 0 },
  mr1: { marginRight: rem(0.25) },
  mr2: { marginRight: rem(0.5) },
  mr3: { marginRight: rem(1) },
  mr4: { marginRight: rem(2) },
  mr5: { marginRight: rem(4) },
  mr6: { marginRight: rem(8) },
  mr7: { marginRight: rem(16) },
  mb0: { marginBottom: 0 },
  mb1: { marginBottom: rem(0.25) },
  mb2: { marginBottom: rem(0.5) },
  mb3: { marginBottom: rem(1) },
  mb4: { marginBottom: rem(2) },
  mb5: { marginBottom: rem(4) },
  mb6: { marginBottom: rem(8) },
  mb7: { marginBottom: rem(16) },
  mt0: { marginTop: 0 },
  mt1: { marginTop: rem(0.25) },
  mt2: { marginTop: rem(0.5) },
  mt3: { marginTop: rem(1) },
  mt4: { marginTop: rem(2) },
  mt5: { marginTop: rem(4) },
  mt6: { marginTop: rem(8) },
  mt7: { marginTop: rem(16) },
  mv0: { marginTop: 0, marginBottom: 0 },
  mv1: { marginTop: rem(0.25), marginBottom: rem(0.25) },
  mv2: { marginTop: rem(0.5), marginBottom: rem(0.5) },
  mv3: { marginTop: rem(1), marginBottom: rem(1) },
  mv4: { marginTop: rem(2), marginBottom: rem(2) },
  mv5: { marginTop: rem(4), marginBottom: rem(4) },
  mv6: { marginTop: rem(8), marginBottom: rem(8) },
  mv7: { marginTop: rem(16), marginBottom: rem(16) },
  mh0: { marginLeft: 0, marginRight: 0 },
  mh1: { marginLeft: rem(0.25), marginRight: rem(0.25) },
  mh2: { marginLeft: rem(0.5), marginRight: rem(0.5) },
  mh3: { marginLeft: rem(1), marginRight: rem(1) },
  mh4: { marginLeft: rem(2), marginRight: rem(2) },
  mh5: { marginLeft: rem(4), marginRight: rem(4) },
  mh6: { marginLeft: rem(8), marginRight: rem(8) },
  mh7: { marginLeft: rem(16), marginRight: rem(16) },
  na1: { margin: -rem(0.25) },
  na2: { margin: -rem(0.5) },
  na3: { margin: -rem(1) },
  na4: { margin: -rem(2) },
  na5: { margin: -rem(4) },
  na6: { margin: -rem(8) },
  na7: { margin: -rem(16) },
  nl1: { marginLeft: -rem(0.25) },
  nl2: { marginLeft: -rem(0.5) },
  nl3: { marginLeft: -rem(1) },
  nl4: { marginLeft: -rem(2) },
  nl5: { marginLeft: -rem(4) },
  nl6: { marginLeft: -rem(8) },
  nl7: { marginLeft: -rem(16) },
  nr1: { marginRight: -rem(0.25) },
  nr2: { marginRight: -rem(0.5) },
  nr3: { marginRight: -rem(1) },
  nr4: { marginRight: -rem(2) },
  nr5: { marginRight: -rem(4) },
  nr6: { marginRight: -rem(8) },
  nr7: { marginRight: -rem(16) },
  nb1: { marginBottom: -rem(0.25) },
  nb2: { marginBottom: -rem(0.5) },
  nb3: { marginBottom: -rem(1) },
  nb4: { marginBottom: -rem(2) },
  nb5: { marginBottom: -rem(4) },
  nb6: { marginBottom: -rem(8) },
  nb7: { marginBottom: -rem(16) },
  nt1: { marginTop: -rem(0.25) },
  nt2: { marginTop: -rem(0.5) },
  nt3: { marginTop: -rem(1) },
  nt4: { marginTop: -rem(2) },
  nt5: { marginTop: -rem(4) },
  nt6: { marginTop: -rem(8) },
  nt7: { marginTop: -rem(16) },
  tl: { textAlign: 'left' },
  tr: { textAlign: 'right' },
  tc: { textAlign: 'center' },
  f1: { fontSize: rem(3) },
  f2: { fontSize: rem(2.25) },
  f3: { fontSize: rem(1.5) },
  f4: { fontSize: rem(1.25) },
  f5: { fontSize: rem(1) },
  f6: { fontSize: rem(0.875) },
  f7: { fontSize: rem(0.75) },
  center: { marginRight: 'auto', marginLeft: 'auto' },
  'mr-auto': { marginRight: 'auto' },
  'ml-auto': { marginLeft: 'auto' },
  dim: { opacity: 1 },
  'dim-active': { opacity: 0.8 },
  z0: { zIndex: 0 },
  z1: { zIndex: 1 },
  z2: { zIndex: 2 },
  z3: { zIndex: 3 },
  z4: { zIndex: 4 },
  z5: { zIndex: 5 },
  z999: { zIndex: 999 },
  z9999: { zIndex: 9999 },
  'z-max': { zIndex: 2147483647 },
  underline: { textDecorationLine: 'underline' },
  strike: { textDecorationLine: 'line-through' },
  ttc: { textTransform: 'capitalize' },
  ttu: { textTransform: 'uppercase' },
  img: { maxWidth: '100%' },
  measure: { maxWidth: rem(30) },
  'measure-wide': { maxWidth: rem(34) },
  'measure-narrow': { maxWidth: rem(20) },
  'lh-solid': { lineHeight: 1 },
  'lh-title': { lineHeight: 1.25 },
  'lh-copy': { lineHeight: 1.5 },
  tracked: { letterSpacing: rem(0.1) },
  'tracked-tight': { letterSpacing: -rem(0.5) },
  'tracked-mega': { letterSpacing: rem(0.25) },
  'l-bgc-primary-black': { backgroundColor: 'black' },
};

module.exports = tachyons;
